﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinGrid;

namespace WindowsFormsApplication36
{
    public partial class Form1 : Form
    {
        List<RowAlphaInfo> rowAlpaInfos = new List<RowAlphaInfo>();
        public Form1()
        {
            InitializeComponent();
        }

        private void ultraGrid1_DoubleClickRow(object sender, Infragistics.Win.UltraWinGrid.DoubleClickRowEventArgs e)
        {
            this.rowAlpaInfos.Add(new RowAlphaInfo(e.Row));
            this.StartTimer();

        }

        private void StartTimer()
        {
            if (false == this.timer1.Enabled)
                this.timer1.Start();
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            short increment = 15;

            // Copy the rowAlphaInfos into an array. This will allow us to remove items from the
            // List without affecting the foreach iterator. 
            RowAlphaInfo[] rowAlphaInfos = this.rowAlpaInfos.ToArray<RowAlphaInfo>();
            foreach (RowAlphaInfo rowAlphaInfo in rowAlphaInfos)
            {
                UltraGridRow row = rowAlphaInfo.Row;

                rowAlphaInfo.Alpha -= increment;
                short alpha = rowAlphaInfo.Alpha;

                if (alpha > 0)
                {
                    row.Appearance.AlphaLevel = alpha;
                    row.RowSelectorAppearance.AlphaLevel = alpha;
                }
                else
                {
                    this.rowAlpaInfos.Remove(rowAlphaInfo);
                    row.Delete(false);                    
                }
            }

            if (this.rowAlpaInfos.Count == 0)
                this.timer1.Stop();
        }

        private void Form1_Load(object sender, EventArgs e)
        {

        }
    }

    public class RowAlphaInfo
    {
        public RowAlphaInfo(UltraGridRow row)
        {
            this.Row = row;
            this.Alpha = 255;
        }

        public UltraGridRow Row { get; set; }
        public short Alpha { get; set; }
    }
}
